<template>
    <v-container fluid>
        <v-alert :value="valueAlarm" color="warning" outlined>
            Esta tardando más de lo esperado, esto puede ocurrir a causa de la baja velocidad de internet
        </v-alert>
        <v-container class="toolbar-kpi" fluid fill-height>
            <v-row style="align-items: center;">
                <v-col cols="12" sm="3">
                    <div class="toolbar-kpi">
                        <HexButton style="margin-right: 20px;" @click="$router.back()">
                            <v-icon size="35">mdi-arrow-left</v-icon>
                        </HexButton>
                        <span class="title-kpi">Regresar</span>
                    </div>
                </v-col>
                <v-row>
                    <v-col cols="12" md="4" sm="4">
                        <LargeHexButton
                            :check="menuHead.DELIVERY"
                            title="Delivery"
                            @click="setPrincipalOptions(TypeOrder.DELIVERY, recordMenuViewsDeliveryPerDay)"
                        ></LargeHexButton>
                    </v-col>
                    <v-col cols="12" md="4" sm="4">
                        <LargeHexButton
                            :check="menuHead.COLLECT"
                            title="Pickup"
                            @click="setPrincipalOptions(TypeOrder.COLLECT, recordMenuViewsCollectPerDay)"
                        ></LargeHexButton>
                    </v-col>
                    <v-col cols="12" md="4" sm="4">
                        <LargeHexButton
                            :check="menuHead.LOCAL"
                            title="Local"
                            @click="setPrincipalOptions(TypeOrder.LOCAL, recordMenuViewsPerDay)"
                        ></LargeHexButton>
                    </v-col>
                </v-row>

                <v-col cols="12" sm="3">
                    <div class="toolbar-kpi">
                        <v-row justify="center">
                            <span class="mr-20 title-kpi">Filtrar</span>
                            <v-menu bottom offset-y>
                                <template v-slot:activator="{ on, attrs }">
                                    <v-btn v-bind="attrs" v-on="on" class="btnfilter">
                                        <HexButton style="margin-left: 20px;"
                                            ><v-icon size="35">mdi-tune</v-icon></HexButton
                                        >
                                    </v-btn>
                                </template>
                                <v-list class="title-kpi" md="4" style="background-color: #e5ebf7;">
                                    <v-list-item>
                                        <circle-check-button
                                            :check="filterMenuHead.DAY"
                                            @click="setFilterOptions(stateMenu, FilterOrder.DAY, DataRange.DAILY)"
                                        ></circle-check-button
                                        ><span class="ma-3">Por día</span>
                                    </v-list-item>
                                    <v-list-item>
                                        <circle-check-button
                                            :check="filterMenuHead.WEEK"
                                            @click="setFilterOptions(stateMenu, FilterOrder.WEEK, DataRange.WEEKLY)"
                                        ></circle-check-button
                                        ><span class="ma-3">Por semana</span>
                                    </v-list-item>
                                    <v-list-item>
                                        <circle-check-button
                                            :check="filterMenuHead.MONTH"
                                            @click="setFilterOptions(stateMenu, FilterOrder.MONTH, DataRange.MONTHLY)"
                                        ></circle-check-button
                                        ><span class="ma-3">Por mes</span>
                                    </v-list-item>
                                </v-list>
                            </v-menu>
                        </v-row>
                    </div>
                </v-col>
            </v-row>
        </v-container>
        <v-row style="justify-content: center;">
            <v-col cols="12" lg="12">
                <span class="title-kpi">Históricos de visitas {{ filterView }}</span>
            </v-col>
            <v-col cols="12" lg="10">
                <div class="d-flex">
                    <GraphLine :data="recordMenuView"></GraphLine>
                </div>
            </v-col>
        </v-row>
        <v-responsive style="height: 150px; margin: 0px!important; position: relative" v-if="isLoading">
            <v-row class="fill-height" align-content="center" justify="center" v-if="isLoading">
                <v-col class="subtitle-1 text-center" cols="12">
                    <p>Obteniendo datos..</p>
                </v-col>
                <v-col cols="6">
                    <span v-if="!isLoading"></span>
                    <v-progress-linear
                        v-else
                        indeterminate
                        rounded
                        height="6"
                        color="yellow darken-2"
                    ></v-progress-linear>
                    <v-dialog
                        fullscreen
                        persistent
                        v-model="isLoading"
                        class="loader"
                        style="background-color: black"
                        overlay
                        transition="dialog-bottom-transition"
                    ></v-dialog>
                    <v-overlay :value="isLoading"></v-overlay>
                </v-col>
            </v-row>
        </v-responsive>
        <ProductsTop
            v-if="photosMax.length > 0 || photosMin.length > 0"
            :photosMax="photosMax"
            :photosMin="photosMin"
            style="margin-bottom: 50px;"
        ></ProductsTop>
        <v-row style="justify-content: center;">
            <v-col cols="12" md="12" lg="6" no-gutters>
                <convertion-rate :datas="datas" :views="totalViews" :sales-percent="percentOfSales"></convertion-rate>
            </v-col>
            <sales-marker :completedSales="orderCompletedByType" :cancelSales="orderCancelByType"></sales-marker>
        </v-row>
    </v-container>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { Action, namespace } from 'vuex-class';
import { KPIService } from '@/services/KPIService';
import { Restaurant } from '@/model/Restaurant';
import { Menu as ModelMenu } from '@/model/menu/Menu';
import GraphLine from '@/components/kpi/GraphLine.vue';
import HexButton from '@/components/commons/HexButton.vue';
import LargeHexButton from '@/components/commons/LargeHexButton.vue';
import { Order, StatusOrder, TypeOrder } from '@/model/order/Order';
import { ProductsViews, RecordMenuViews } from '@/model/kpi/View';
import { AsyncComponentPromise } from 'vue/types/options';
import CircleCheckButton from '@/components/commons/CircleCheckButton.vue';
import { Dish } from '@/model/menu/Dish';
import { DishService } from '@/services/DishService';
import ProductsTop from '@/components/kpi/ProductsTop.vue';
import SalesMarker from '@/components/kpi/SalesMarker.vue';
import ConvertionRate from '@/components/kpi/ConvertionRate.vue';
import { DataRange } from '@/model/DataRange';
import { FilterOrder } from '@/model/kpi/KpiFilterOrder';
import { getFile } from '@/services/StorageService';

const kpiStore = namespace('KpiModule');
const orderStore = namespace('OrderModule');

@Component({
    components: {
        ConvertionRate,
        SalesMarker,
        ProductsTop,
        CircleCheckButton,
        GraphLine,
        HexButton,
        LargeHexButton
    }
})
export default class Menu extends Vue {
    @orderStore.State
    orders!: Order[];
    @kpiStore.State
    menuHead!: { DELIVERY: boolean; COLLECT: boolean; LOCAL: boolean };
    @kpiStore.State
    filterMenuHead!: { DAY: boolean; WEEK: boolean; MONTH: boolean };
    @kpiStore.State
    stateMenu!: string;
    @kpiStore.State
    stateFilter!: string;

    @kpiStore.State
    recordMenuViewsMonth!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsWeek!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsPerDay!: RecordMenuViews[];

    @kpiStore.State
    recordMenuViewsDeliveryPerDay!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsDeliveryWeek!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsDeliveryMonth!: RecordMenuViews[];

    @kpiStore.State
    recordMenuViewsCollectPerDay!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsCollectWeek!: RecordMenuViews[];
    @kpiStore.State
    recordMenuViewsCollectMonth!: RecordMenuViews[];

    //+ADDED
    @kpiStore.State
    recordMenuViewsLocal!: RecordMenuViews[];

    @orderStore.Action
    findOrdersForRestaurant!: (restaurantId: string) => AsyncComponentPromise<string>;
    @kpiStore.Action
    getViewsForMenu!: (payload: { menuId: string }) => Promise<void>;

    @Action('changeLoading')
    changeAction!: (payload: boolean) => Promise<void>;

    @kpiStore.Action
    setOptionMenu!: (payload: { optionMenu: TypeOrder }) => Promise<void>;
    @kpiStore.Action
    setFilterOption!: (payload: { filterOptions: FilterOrder }) => Promise<void>;

    @kpiStore.Action
    setStateMenu!: (payload: { menuOpc: string }) => Promise<void>;
    @kpiStore.Action
    setStateFilter!: (payload: { stateFilter: string }) => Promise<void>;
    @Prop()
    restaurant!: Restaurant;
    @Prop()
    menu!: ModelMenu;

    kpiService = new KPIService();
    dishService = new DishService();

    isLoading = false;
    dialog = false;

    recordMenuView: RecordMenuViews[] = [];
    dish: Dish[] = [];

    totalViews = 0;
    percentOfSales = 0;
    orderCompletedByType = 0;
    orderCancelByType = 0;

    photosByType: ProductsViews[] = [];
    photosMin: ProductsViews[] = [];
    photosMax: ProductsViews[] = [];

    datas: ProductsViews[] = [];
    filterView = '';
    TypeOrder = TypeOrder;
    StatusOrder = StatusOrder;
    FilterOrder = FilterOrder;
    DataRange = DataRange;
    valueAlarm = false;

    async created() {
        this.isLoading = true;
        this.findOrdersForRestaurant(this.restaurant.id);
        await this.getViewsForMenu({ menuId: this.menu.id });
        await this.setOptionMenu({ optionMenu: TypeOrder.DELIVERY });
        await this.setFilterOption({ filterOptions: FilterOrder.DAY });
        await this.setStateMenu({ menuOpc: 'DELIVERY' });
        await this.setStateFilter({ stateFilter: 'DAY' });
        await this.setInitialData(
            TypeOrder.DELIVERY,
            StatusOrder.COMPLETED,
            StatusOrder.CANCEL,
            this.orders,
            this.recordMenuViewsPerDay,
            DataRange.DAILY
        );
        this.isLoading = false;

        console.log('RECORDS BY LOCAL 2M', this.recordMenuViewsLocal)
    }

    @Watch('stateFilter')
    onChangeData(newVal: string) {
        if (newVal) {
            const newFilterState = this.stateFilter;
            let newStateMenu = this.stateMenu;
            let newRecord: RecordMenuViews[] = [];
            let orderType = '';
            let newRecordViews: RecordMenuViews[] = [];

            switch (newStateMenu) {
                case 'DELIVERY':
                    newStateMenu = this.TypeOrder.DELIVERY;
                    switch (newFilterState) {
                        case 'DAY':
                            newRecord = this.recordMenuViewsDeliveryPerDay;
                            break;
                        case 'WEEK':
                            newRecord = this.recordMenuViewsDeliveryWeek;
                            break;
                        case 'MONTH':
                            newRecord = this.recordMenuViewsDeliveryMonth;
                            break;
                    }
                    break;
                case 'COLLECT':
                    newStateMenu = this.TypeOrder.COLLECT;
                    switch (newFilterState) {
                        case 'DAY':
                            newRecord = this.recordMenuViewsCollectPerDay;
                            break;
                        case 'WEEK':
                            newRecord = this.recordMenuViewsCollectWeek;
                            break;
                        case 'MONTH':
                            newRecord = this.recordMenuViewsCollectMonth;
                            break;
                    }
                    break;
                case 'LOCAL':
                    newStateMenu = this.TypeOrder.LOCAL;
                    switch (newFilterState) {
                        case 'DAY':
                            newRecord = this.recordMenuViewsPerDay;
                            break;
                        case 'WEEK':
                            newRecord = this.recordMenuViewsWeek;
                            break;
                        case 'MONTH':
                            newRecord = this.recordMenuViewsMonth;
                            break;
                    }
                    break;
            }
            switch (newVal) {
                case 'DAY':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
                case 'WEEK':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
                case 'MONTH':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
            }
            this.setInitialData(
                newStateMenu as TypeOrder,
                StatusOrder.COMPLETED,
                StatusOrder.CANCEL,
                this.orders,
                newRecord,
                DataRange.DAILY
            );
        }
    }

    @Watch('stateMenu')
    onChangeData2(newVal: string) {
        if (newVal) {
            let newFilterState = this.stateFilter;
            const newStateMenu = this.stateMenu;
            let newRecord: RecordMenuViews[] = [];
            let orderType = '';
            let newRecordViews: RecordMenuViews[] = [];

            switch (newFilterState) {
                case 'DAY':
                    newFilterState = FilterOrder.DAY;
                    switch (newStateMenu) {
                        case 'DELIVERY':
                            newRecord = this.recordMenuViewsDeliveryPerDay;
                            break;
                        case 'COLLECT':
                            newRecord = this.recordMenuViewsCollectPerDay;
                            break;
                        case 'LOCAL':
                            newRecord = this.recordMenuViewsPerDay;
                            break;
                    }
                    break;
                case 'WEEK':
                    newFilterState = FilterOrder.WEEK;
                    switch (newStateMenu) {
                        case 'DELIVERY':
                            newRecord = this.recordMenuViewsDeliveryWeek;
                            break;
                        case 'COLLECT':
                            newRecord = this.recordMenuViewsCollectWeek;
                            break;
                        case 'LOCAL':
                            newRecord = this.recordMenuViewsWeek;
                            break;
                    }
                    break;
                case 'MONTH':
                    newFilterState = FilterOrder.MONTH;
                    switch (newStateMenu) {
                        case 'DELIVERY':
                            newRecord = this.recordMenuViewsDeliveryMonth;
                            break;
                        case 'COLLECT':
                            newRecord = this.recordMenuViewsCollectMonth;
                            break;
                        case 'LOCAL':
                            newRecord = this.recordMenuViewsMonth;
                            break;
                    }
                    break;
            }
            switch (newVal) {
                case 'DELIVERY':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
                case 'COLLECT':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
                case 'LOCAL':
                    orderType = newStateMenu as TypeOrder;
                    newRecordViews = newRecord;
                    break;
            }
            this.setInitialData(
                orderType as TypeOrder,
                StatusOrder.COMPLETED,
                StatusOrder.CANCEL,
                this.orders,
                newRecordViews,
                DataRange.DAILY
            );
        }
    }

    setPrincipalOptions(Types: TypeOrder, menuViews: RecordMenuViews[]) {
        this.setOptionMenu({ optionMenu: Types });
        this.setStateMenu({ menuOpc: Types });
        this.setInitialData(Types, StatusOrder.COMPLETED, StatusOrder.CANCEL, this.orders, menuViews, DataRange.DAILY);
    }
    setFilterOptions(orderType: string, filter: FilterOrder, dataRange: DataRange) {
        this.setFilterOption({ filterOptions: filter });
        this.setStateFilter({ stateFilter: filter });
        this.setInitialData(
            orderType as TypeOrder,
            StatusOrder.COMPLETED,
            StatusOrder.CANCEL,
            this.orders,
            [],
            dataRange
        );
    }
    setTotalViews() {
        const views = this.recordMenuView.map(data => data.view);
        this.totalViews = views.reduce((a, b) => a + b) || 0;
    }
    setDataPie(data1: number) {
        this.datas = [
            { value: data1, name: 'Ventas confirmadas', photos: [], createdAt: new Date() },
            { value: this.totalViews - data1, name: 'visitas', photos: [], createdAt: new Date() }
        ];
    }

    async setInitialData(
        types: TypeOrder,
        statusCompleted: StatusOrder,
        statusCancel: StatusOrder,
        order: Order[],
        viewsByDateRange: RecordMenuViews[],
        productRange: DataRange
    ) {
        const localOrdersCompleted: number = await this.getOrdersFilters(productRange, types, statusCompleted, order);
        const localOrdersCancel: number = await this.getOrdersFilters(productRange, types, statusCancel, order);
        this.recordMenuView = viewsByDateRange;
        try {
            this.setTotalViews();
        } catch (e) {
            console.log('');
        }
        await this.setProductsByType(productRange, types);
        //Restricciones y set para productos más vistos
        await this.setProductViewMax();
        //Restricciones y set para productos menos vistos
        await this.setProductViewMin();
        this.orderCompletedByType = localOrdersCompleted;
        this.orderCancelByType = localOrdersCancel;
        const onePercent = this.totalViews / 100;
        const res = localOrdersCompleted / onePercent;
        this.percentOfSales = isNaN(res) ? 0 : res;
        this.setDataPie(this.orderCompletedByType);
    }
    async setProductsByType(days: DataRange, typeDish: TypeOrder): Promise<ProductsViews[]> {
        this.isLoading = true;
        this.photosMin = [];
        this.photosMax = [];
        const isSlow = setTimeout(() => {
            this.valueAlarm = true;
        }, 15000);
        const dishes = await this.dishService.getDishesFromMenu(this.menu.id);
        const viewsByType = await this.kpiService.getProductsViews(this.menu.id, dishes as Dish[], days, typeDish);
        const viewsByDateRange = await this.getProductsViewsByDateRange(viewsByType, days);
        this.isLoading = false;
        clearTimeout(isSlow);
        !this.isLoading ? (this.valueAlarm = false) : true;
        return (this.photosByType = viewsByDateRange);
    }
    async setProductViewMin() {
        const datas = this.photosByType;
        const size = this.photosByType.length;
        const isMinusOrFive = datas.slice(size - 1, size);
        const isOne = datas.slice(size, size);
        const max = size - 5;
        const isPlusFive = datas.slice(size - max, size);

        if (size <= 5) {
            size == 1 ? (this.photosMin = isOne) : (this.photosMin = isMinusOrFive);
        } else {
            this.photosMin = isPlusFive;
        }
    }
    async setProductViewMax() {
        const datas = this.photosByType;
        const size = this.photosByType.length;
        const isMinusOrFive = datas.slice(0, size - 1);
        const isOne = datas.slice(0, size);
        const isPlusFive = datas.slice(0, 5);
        if (size < 5) {
            size == 1 ? (this.photosMax = isOne) : (this.photosMax = isMinusOrFive);
        } else {
            this.photosMax = isPlusFive;
        }
    }

    //Obtiene las url e información del path photo en storage  a traves del metodo getFilesPreview
    async getProductsViewsByDateRange(data: ProductsViews[], days: DataRange): Promise<ProductsViews[]> {
        const date = new Date();
        const startDate = new Date();
        const endDate = new Date();
        const currentYear = startDate.getFullYear();
        const month = date.getMonth();

        switch (days) {
            case DataRange.MONTHLY:
                startDate.setFullYear(currentYear, startDate.getMonth() - 1, 1);
                startDate.setHours(0, 0, 0);
                endDate.setMonth(endDate.getMonth(), 0);
                endDate.setHours(23, 59, 59);
                if (month === 0) {
                    startDate.setFullYear(currentYear - 1, 11, 1);
                }
                break;
            default:
                startDate.setFullYear(currentYear, startDate.getMonth(), startDate.getDate() - days);
                startDate.setHours(0, 0, 0);
                endDate.setFullYear(currentYear, endDate.getMonth(), endDate.getDate());
                endDate.setHours(23, 59, 59);
                break;
        }

        const photos: ProductsViews[] = [];

        for (const productView of data) {
            const photoUrl = await getFile(productView.photos.length ? productView.photos[0] : null);
            photos.push(new ProductsViews(productView.name, productView.value, [photoUrl], productView.createdAt));
        }
        const filteredItems = photos.filter(item => item.createdAt >= startDate && item.createdAt <= endDate);
        return filteredItems;
    }
    async getOrdersFilters(dataRange: DataRange, type: TypeOrder, status: StatusOrder, orders: Order[]) {
        const deliveryOrder: Order[] = orders.filter(order => order.type === type && order.status === status);
        return this.getOrdersByDateRange(deliveryOrder, dataRange, status);
    }
    //Obtiene el filtro de ordenes de acuerdo a Rango de tiempo(DAY, MONTHLY, WEEKLY)
    getOrdersByDateRange(deliveryOrder: Order[], days: DataRange, status: StatusOrder) {
        const date = new Date();
        const startDate = new Date();
        const endDate = new Date();
        const currentYear = startDate.getFullYear();
        const month = date.getMonth();
        switch (days) {
            case DataRange.MONTHLY:
                startDate.setFullYear(currentYear, month - 1, 1);
                startDate.setHours(0, 0, 0);
                endDate.setFullYear(currentYear, month - 1, 31);
                endDate.setHours(23, 59, 59);
                if (month === 0) {
                    startDate.setFullYear(currentYear - 1, 11, 1);
                }
                break;
            default:
                startDate.setFullYear(currentYear, month, startDate.getDate() - days);
                startDate.setHours(0, 0, 0);
                endDate.setFullYear(currentYear, startDate.getMonth(), endDate.getDate());
                endDate.setHours(23, 59, 59);
                break;
        }
        const filteredItems = deliveryOrder.filter(item => item.createdAt >= startDate && item.createdAt <= endDate);
        const stat = filteredItems.filter(items => items.status == status);
        const totalView = stat.length;
        return totalView;
    }
}
</script>

<style lang="scss">
.loader {
    position: fixed;
    left: 0px;
    top: 0px;
    width: 100%;
    height: 100%;
    z-index: 999;
    opacity: 1;
    background-color: black;
}
.toolbar-kpi {
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 0 5px;
}
.title-kpi {
    font-weight: 800;
    color: #000;
    white-space: nowrap;
}
.title-photo {
    font-weight: 800;
    color: #000;
    white-space: nowrap;
}
.title-kpi-pie {
    font-size: 40px;
    font-weight: 800;
    color: #000;
    white-space: nowrap;
}
.btnfilter {
    padding: 0;
    border: 0px solid;
    background-color: transparent !important;
    border-color: inherit;
    -webkit-box-shadow: none;
    box-shadow: none;
}
</style>
